<template>
  <div class="execution">
    <basic-container>
      <avue-crud ref="crud" :page.sync="page" :data="tableData" :permission="permissionList"
        :table-loading="tableLoading" :option="tableOption" @on-load="getList" @search-change="searchChange"
        @refresh-change="refreshChange" @size-change="sizeChange" @current-change="currentChange"
        @row-update="handleUpdate" @row-save="handleSave" @row-del="handleDel">
      </avue-crud>
    </basic-container>
  </div>
</template>

<script>
  import {
    fetchList,
    getObj,
    addObj,
    putObj,
    delObj
  } from '@/api/systemSet/account.js'
  import {
    getSystemSet,
    configSystemSet
  } from '@/api/systemSet/systemSet.js'
  import {
    tableOption
  } from '@/const/crud/systemSet/account.js'
  import {
    mapGetters
  } from 'vuex'
  import {
    ZmMixin
  } from '@/mixins/ZmMixin.js'

  //console.log(tableOption)

  export default {
    name: 'basebankaccount',
    mixins: [ZmMixin],
    data() {
      return {
        key: 'SYSTEM_SET_ACCOUNT_SET',
        searchForm: {},
        tableData: [],
        page: {
          total: 0, // 总页数
          currentPage: 1, // 当前页数
          pageSize: 20 // 每页显示多少条
        },
        tableLoading: false,
        tableOption: tableOption
      }
    },
    computed: {
      ...mapGetters(['permissions']),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permissions.general_basebankaccount_add, false),
          delBtn: this.vaildData(this.permissions.general_basebankaccount_del, false),
          editBtn: this.vaildData(this.permissions.general_basebankaccount_edit, false)
        };
      }
    },
    created() {
      this.refreshChange()
    },
    methods: {
      // 列表查询
      getList(page, params) {
        this.tableLoading = true
        getSystemSet({
          key: this.key
        }).then(response => {
          let r = this.zmRes(response)
          if (r) {
            this.tableData = r
            this.page.total = r.length || 0
          }
          this.tableLoading = false
        }).catch(() => {
          this.tableLoading = false
        })
      },
      // 删除
      handleDel: function(row, index) {
        row.isDelete = 1
        this.$confirm('是否确认删除?', '提示', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        }).then(() => {
          return configSystemSet({
            key: this.key,
            data: JSON.stringify(row)
          })
        }).then(data => {
          this.$message.success('删除成功')
          this.getList(this.page)
        })
      },
      // 更新
      handleUpdate: function(row, index, done, loading) {
        configSystemSet({
          key: this.key,
          data: JSON.stringify(row)
        }).then(data => {
          this.$message.success('修改成功')
          done()
          this.getList(this.page)
        }).catch(() => {
          loading();
        });
      },
      // 保存
      handleSave: function(row, done, loading) {
        configSystemSet({
          key: this.key,
          data: JSON.stringify(row)
        }).then(data => {
          this.$message.success('添加成功')
          done()
          this.getList(this.page)
        }).catch(() => {
          loading();
        });
      },
      // 每页条数改变事件
      sizeChange(pageSize) {
        this.page.pageSize = pageSize
      },
      // 当前页发生改变事件
      currentChange(current) {
        this.page.currentPage = current
      },
      // 查询事件
      searchChange(form, done) {
        this.searchForm = form
        this.page.currentPage = 1
        this.getList(this.page, form)
        done()
      },
      // 刷新事件
      refreshChange() {
        this.getList(this.page)
      },
      //  导出excel
      exportExcel() {
        this.downBlobFile('/general/basebankaccount/export', this.searchForm, 'basebankaccount.xlsx')
      }
    }
  }
</script>
